
declare
v_grid_name varchar2(6);
v_grid_id number(14, 0);
v_field_id number(14, 0);
v_field_id_list VARCHAR2(1000);
v_grid_key_fields VARCHAR2(200);
v_dataspy_id number(14, 0);
sChk varchar2(3);
r5boilertexts_exists integer;
r5grid_exists integer;
r5functions_exists integer;
sequence_check varchar2(3);
v_language VARCHAR2(2);

begin
v_grid_name := 'WUAUTH';
v_language := '&1';

select count(*) into r5boilertexts_exists
from r5boilertexts
where BOT_FUNCTION = v_grid_name
and rownum = 1;

IF r5boilertexts_exists = 1 THEN
	DELETE FROM r5boilertexts where BOT_FUNCTION = v_grid_name;
END IF;

select count(*) into r5grid_exists
from r5grid
where GRD_GRIDNAME = v_grid_name
and rownum = 1;

IF r5grid_exists = 1 THEN
  DELETE FROM r5queryfield where DQF_DDSPYID in (select DDS_DDSPYID from R5dddataspy where DDS_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = v_grid_name));
  DELETE FROM R5dddataspy WHERE DDS_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = v_grid_name);
  DELETE FROM r5gridfield where GFD_GRIDID in (select grd_gridid from r5grid where GRD_GRIDNAME = v_grid_name);
  DELETE FROM r5gridparam where gdp_gridid in (select grd_gridid from r5grid where GRD_GRIDNAME = v_grid_name);  
  DELETE FROM r5grid WHERE GRD_GRIDNAME = v_grid_name;
END IF;

select count(*) into r5functions_exists
from r5functions
where FUN_CODE = v_grid_name
and rownum = 1;

IF r5functions_exists = 1 THEN
  DELETE FROM R5EXTMENULANG WHERE EML_EXTMENU IN (SELECT EMN_CODE FROM R5EXTMENUS WHERE EMN_FUNCTION = v_grid_name);
  DELETE FROM R5EXTMENUS WHERE EMN_FUNCTION = v_grid_name;
  DELETE FROM r5functions where FUN_CODE = v_grid_name;
END IF;

--Insert Function Here
insert into r5functions (FUN_CODE, FUN_DESC, FUN_CLASS, FUN_SUBTYPE, FUN_FILE, FUN_PUBLIC, FUN_SELECT, FUN_BACKGROUND, FUN_APPLICATION, FUN_DIRSEL, FUN_SYSTEM, FUN_DISPLAYAP, FUN_DISPLAYFT, FUN_POPUPAP, FUN_POPUPFT, FUN_DESCCHANGED, FUN_CLASS_ORG, FUN_LST, FUN_RS, FUN_HDR, FUN_EWSREPORT, FUN_PRDDATASRC, FUN_EWSURLNEW, FUN_REPDISABLED, FUN_MEKEY)
values (v_grid_name, 'Status Authorizations(AM)', 'WEBD', 'M', 'R5MENU', '-', '?', '-', NULL, '-', '+', '-', '+', '-', '-', '+', '*', '+', '-', '-', '-', '-', '-', '-', 'YN');

r5o7.o7maxseq(v_grid_id, 'GRD', '1', sChk);
--Insert Grid Here
insert into r5grid (GRD_GRIDID, GRD_DESC, GRD_BASEQUERY, GRD_GRIDNAME, GRD_BOTFUNCTION, GRD_PORTLETFLAG, GRD_SECENTITY, GRD_HINTS, GRD_TAB, GRD_GRIDTYPE, GRD_UNITS, GRD_OPTIMIZERON, GRD_DISTINCT, GRD_COMMITFLAG, GRD_CUSTOMFIELDCODE, GRD_NOSCREENDESIGNER)
values (v_grid_id, 'Status Authorizations(AM)',
'FROM r5auth a, r5entities t, r5groups g, r5descriptions e WHERE t.ent_rentity = a.aut_rentity AND       g.ugr_code = a.aut_group AND       e.des_rentity = ''UCOD'' AND       e.des_code    = a.aut_entity AND       e.des_lang    = :parameter.language AND       e.des_rtype   = ''ENTP'' ', v_grid_name, v_grid_name, '-', NULL, NULL, '+', 2, NULL, '-', '-', NULL, NULL, '-');

r5o7.o7maxseq(v_dataspy_id, 'DDS', '1', sChk);
--Insert Dataspy Here
insert into R5dddataspy (DDS_DDSPYNAME, DDS_DDSPYID, DDS_AUTORUN, DDS_SCOPE, DDS_ORGANIZATION, DDS_UPDATESTAMP, DDS_UPDATEBYUSER, DDS_CREATEDSTAMP, DDS_UPDATEABLE, DDS_FILTERSTRXML, DDS_SORTSTRXML, DDS_FIELDLIST, DDS_DISPLAYROW, DDS_OWNER, DDS_GRIDID, DDS_TYPE, DDS_DEFAULTFLAG, DDS_FIELDLIST_PORTLET, DDS_CLIENTROWS, DDS_PORTLETROWS, DDS_HINTS, DDS_BOTNAME, DDS_USERFILTER, DDS_SECURITYDATASPY, DDS_MEKEY)
values ('All Records', v_dataspy_id, NULL, '-', '*', null, NULL, sysdate, NULL, '<FILTERABLE />', '<SORTABLE />', NULL, null, 'R5', v_grid_id, 'SD', '+', NULL, 30, null, NULL, 'DSNAME', NULL, '-', 'YY');

--Insert BoilerTexts Here

insert into r5boilertexts (BOT_FUNCTION, BOT_NUMBER, BOT_LENGTH, BOT_XPOS, BOT_YPOS, BOT_LANG, BOT_TEXT, BOT_DEST, BOT_PAGE, BOT_FLD1, BOT_FLD2, BOT_PRTP, BOT_LVCR, BOT_ADLEN, BOT_POOL, BOT_CHANGED, BOT_DISPLAY, BOT_CLONED)
values (v_grid_name, 1, 100, 0, 0, v_language, 'List View', 'TB', '1', 'LST', NULL, NULL, null, null, '10000', NULL, NULL, '-');

insert into r5boilertexts (BOT_FUNCTION, BOT_NUMBER, BOT_LENGTH, BOT_XPOS, BOT_YPOS, BOT_LANG, BOT_TEXT, BOT_DEST, BOT_PAGE, BOT_FLD1, BOT_FLD2, BOT_PRTP, BOT_LVCR, BOT_ADLEN, BOT_POOL, BOT_CHANGED, BOT_DISPLAY, BOT_CLONED)
values (v_grid_name, 2, 100, 0, 0, v_language, 'All Action Codes(AM)', 'F', '1', 'UDG_HDRLABEL', NULL, NULL, null, null, '10000', '+', NULL, '-');

insert into r5boilertexts (BOT_FUNCTION, BOT_NUMBER, BOT_LENGTH, BOT_XPOS, BOT_YPOS, BOT_LANG, BOT_TEXT, BOT_DEST, BOT_PAGE, BOT_FLD1, BOT_FLD2, BOT_PRTP, BOT_LVCR, BOT_ADLEN, BOT_POOL, BOT_CHANGED, BOT_DISPLAY, BOT_CLONED)
values (v_grid_name, 3, 100, 0, 0, v_language, 'All Records', 'F', '1', 'DSNAME', NULL, NULL, null, null, '10000', NULL, NULL, '-');

insert into r5boilertexts (BOT_FUNCTION, BOT_NUMBER, BOT_LENGTH, BOT_XPOS, BOT_YPOS, BOT_LANG, BOT_TEXT, BOT_DEST, BOT_PAGE, BOT_FLD1, BOT_FLD2, BOT_PRTP, BOT_LVCR, BOT_ADLEN, BOT_POOL, BOT_CHANGED, BOT_DISPLAY, BOT_CLONED)
values (v_grid_name, 6, 100, 0, 0, v_language, 'usergroupcode', 'F', '1', 'usergroupcode', NULL, NULL, null, null, '10000', '-', NULL, '-');

insert into r5boilertexts (BOT_FUNCTION, BOT_NUMBER, BOT_LENGTH, BOT_XPOS, BOT_YPOS, BOT_LANG, BOT_TEXT, BOT_DEST, BOT_PAGE, BOT_FLD1, BOT_FLD2, BOT_PRTP, BOT_LVCR, BOT_ADLEN, BOT_POOL, BOT_CHANGED, BOT_DISPLAY, BOT_CLONED)
values (v_grid_name, 7, 100, 0, 0, v_language, 'usercode', 'F', '1', 'usercode', NULL, NULL, null, null, '10000', '-', NULL, '-');

insert into r5boilertexts (BOT_FUNCTION, BOT_NUMBER, BOT_LENGTH, BOT_XPOS, BOT_YPOS, BOT_LANG, BOT_TEXT, BOT_DEST, BOT_PAGE, BOT_FLD1, BOT_FLD2, BOT_PRTP, BOT_LVCR, BOT_ADLEN, BOT_POOL, BOT_CHANGED, BOT_DISPLAY, BOT_CLONED)
values (v_grid_name, 8, 100, 0, 0, v_language, 'entity', 'F', '1', 'entity', NULL, NULL, null, null, '10000', '-', NULL, '-');

insert into r5boilertexts (BOT_FUNCTION, BOT_NUMBER, BOT_LENGTH, BOT_XPOS, BOT_YPOS, BOT_LANG, BOT_TEXT, BOT_DEST, BOT_PAGE, BOT_FLD1, BOT_FLD2, BOT_PRTP, BOT_LVCR, BOT_ADLEN, BOT_POOL, BOT_CHANGED, BOT_DISPLAY, BOT_CLONED)
values (v_grid_name, 9, 100, 0, 0, v_language, 'fromstatus', 'F', '1', 'fromstatus', NULL, NULL, null, null, '10000', '-', NULL, '-');

insert into r5boilertexts (BOT_FUNCTION, BOT_NUMBER, BOT_LENGTH, BOT_XPOS, BOT_YPOS, BOT_LANG, BOT_TEXT, BOT_DEST, BOT_PAGE, BOT_FLD1, BOT_FLD2, BOT_PRTP, BOT_LVCR, BOT_ADLEN, BOT_POOL, BOT_CHANGED, BOT_DISPLAY, BOT_CLONED)
values (v_grid_name, 10, 100, 0, 0, v_language, 'tostatus', 'F', '1', 'tostatus', NULL, NULL, null, null, '10000', '-', NULL, '-');

insert into r5boilertexts (BOT_FUNCTION, BOT_NUMBER, BOT_LENGTH, BOT_XPOS, BOT_YPOS, BOT_LANG, BOT_TEXT, BOT_DEST, BOT_PAGE, BOT_FLD1, BOT_FLD2, BOT_PRTP, BOT_LVCR, BOT_ADLEN, BOT_POOL, BOT_CHANGED, BOT_DISPLAY, BOT_CLONED)
values (v_grid_name, 11, 100, 0, 0, v_language, 'userspecauth', 'F', '1', 'userspecauth', NULL, NULL, null, null, '10000', '-', NULL, '-');

insert into r5boilertexts (BOT_FUNCTION, BOT_NUMBER, BOT_LENGTH, BOT_XPOS, BOT_YPOS, BOT_LANG, BOT_TEXT, BOT_DEST, BOT_PAGE, BOT_FLD1, BOT_FLD2, BOT_PRTP, BOT_LVCR, BOT_ADLEN, BOT_POOL, BOT_CHANGED, BOT_DISPLAY, BOT_CLONED)
values (v_grid_name, 12, 100, 0, 0, v_language, 'usergroupdesc', 'F', '1', 'usergroupdesc', NULL, NULL, null, null, '10000', '-', NULL, '-');

insert into r5boilertexts (BOT_FUNCTION, BOT_NUMBER, BOT_LENGTH, BOT_XPOS, BOT_YPOS, BOT_LANG, BOT_TEXT, BOT_DEST, BOT_PAGE, BOT_FLD1, BOT_FLD2, BOT_PRTP, BOT_LVCR, BOT_ADLEN, BOT_POOL, BOT_CHANGED, BOT_DISPLAY, BOT_CLONED)
values (v_grid_name, 13, 100, 0, 0, v_language, 'fromstatusdesc', 'F', '1', 'fromstatusdesc', null, null, null, null, '10000', '-', null, '-');

insert into r5boilertexts (BOT_FUNCTION, BOT_NUMBER, BOT_LENGTH, BOT_XPOS, BOT_YPOS, BOT_LANG, BOT_TEXT, BOT_DEST, BOT_PAGE, BOT_FLD1, BOT_FLD2, BOT_PRTP, BOT_LVCR, BOT_ADLEN, BOT_POOL, BOT_CHANGED, BOT_DISPLAY, BOT_CLONED)
values (v_grid_name, 14, 100, 0, 0, v_language, 'tostatusdesc', 'F', '1', 'tostatusdesc', NULL, NULL, null, null, '10000', '-', NULL, '-');

insert into r5boilertexts (BOT_FUNCTION, BOT_NUMBER, BOT_LENGTH, BOT_XPOS, BOT_YPOS, BOT_LANG, BOT_TEXT, BOT_DEST, BOT_PAGE, BOT_FLD1, BOT_FLD2, BOT_PRTP, BOT_LVCR, BOT_ADLEN, BOT_POOL, BOT_CHANGED, BOT_DISPLAY, BOT_CLONED)
values (v_grid_name, 15, 100, 0, 0, v_language, 'entitydesc', 'F', '1', 'entitydesc', NULL, NULL, null, null, '10000', '-', NULL, '-');

insert into r5boilertexts (BOT_FUNCTION, BOT_NUMBER, BOT_LENGTH, BOT_XPOS, BOT_YPOS, BOT_LANG, BOT_TEXT, BOT_DEST, BOT_PAGE, BOT_FLD1, BOT_FLD2, BOT_PRTP, BOT_LVCR, BOT_ADLEN, BOT_POOL, BOT_CHANGED, BOT_DISPLAY, BOT_CLONED)
values (v_grid_name, 16, 100, 0, 0, v_language, 'rentity', 'F', '1', 'rentity', NULL, NULL, null, null, '10000', '-', NULL, '-');

-------------------------------------------------------------------------------
-- Copy the R5BOILERTEXTS for each of the languages in the R5LANGINST
-------------------------------------------------------------------------------

INSERT INTO R5BOILERTEXTS (BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,BOT_LANG,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_FLD2,BOT_PRTP,BOT_LVCR,BOT_ADLEN,BOT_POOL,BOT_CHANGED,BOT_DISPLAY,BOT_CREATED,BOT_CLONED)
SELECT BOT_FUNCTION,BOT_NUMBER,BOT_LENGTH,BOT_XPOS,BOT_YPOS,LIN_CODE,BOT_TEXT,BOT_DEST,BOT_PAGE,BOT_FLD1,BOT_FLD2,BOT_PRTP,BOT_LVCR,BOT_ADLEN,BOT_POOL,BOT_CHANGED,BOT_DISPLAY,BOT_CREATED,BOT_CLONED
FROM R5BOILERTEXTS, R5LANGINST
WHERE
BOT_LANG = v_language AND BOT_FUNCTION = v_grid_name AND lin_code <> v_language;

--Insert Fields/GridFields/QueryFields Here
r5o7.o7maxseq(v_field_id, 'DDF', '1', sChk);
v_field_id_list := LTRIM(RTRIM(v_field_id));
insert into r5ddfield (DDF_FIELDID, DDF_SOURCENAME, DDF_DATATYPE, DDF_DESC, DDF_VALUEMAPID, DDF_RENTITY, DDF_LVGRID)
values (v_field_id, 'a.aut_group', 'VARCHAR', NULL, null, NULL, NULL);
insert into r5gridfield (GFD_FIELDID, GFD_GRIDID, GFD_BOTFUNCTION, GFD_BOTNUMBER, GFD_CONTROLTYPE, GFD_SCRIPTEVENT, GFD_TAGNAME, GFD_TAGPARAMS, GFD_AGGFUNC, GFD_FIELDTYPE, GFD_OCCURRENCE, GFD_DEPENDENT, GFD_SECENTITY)
values (v_field_id, v_grid_id, v_grid_name, 6, 'TEXT', NULL, 'usergroupcode', NULL, NULL, 'n', 1, null, NULL);
insert into r5queryfield (DQF_DDSPYID, DQF_FIELDID, DQF_COLUMNWIDTH, DQF_COLUMNORDER, DQF_UPDATECOUNT, DQF_VIEWTYPE)
values (v_dataspy_id, v_field_id, '180', 1, 0, 'LIST');


r5o7.o7maxseq(v_field_id, 'DDF', '1', sChk);
v_field_id_list := v_field_id_list || ',' || LTRIM(RTRIM(v_field_id));
insert into r5ddfield (DDF_FIELDID, DDF_SOURCENAME, DDF_DATATYPE, DDF_DESC, DDF_VALUEMAPID, DDF_RENTITY, DDF_LVGRID)
values (v_field_id, 'a.aut_user', 'VARCHAR', NULL, null, NULL, NULL);
insert into r5gridfield (GFD_FIELDID, GFD_GRIDID, GFD_BOTFUNCTION, GFD_BOTNUMBER, GFD_CONTROLTYPE, GFD_SCRIPTEVENT, GFD_TAGNAME, GFD_TAGPARAMS, GFD_AGGFUNC, GFD_FIELDTYPE, GFD_OCCURRENCE, GFD_DEPENDENT, GFD_SECENTITY)
values (v_field_id, v_grid_id, v_grid_name, 7, 'TEXT', NULL, 'usercode', NULL, NULL, 'n', 1, null, NULL);
insert into r5queryfield (DQF_DDSPYID, DQF_FIELDID, DQF_COLUMNWIDTH, DQF_COLUMNORDER, DQF_UPDATECOUNT, DQF_VIEWTYPE)
values (v_dataspy_id, v_field_id, '180', 2, 0, 'LIST');


r5o7.o7maxseq(v_field_id, 'DDF', '1', sChk);
v_field_id_list := v_field_id_list || ',' || LTRIM(RTRIM(v_field_id));
insert into r5ddfield (DDF_FIELDID, DDF_SOURCENAME, DDF_DATATYPE, DDF_DESC, DDF_VALUEMAPID, DDF_RENTITY, DDF_LVGRID)
values (v_field_id, 'a.aut_entity', 'VARCHAR', NULL, null, NULL, NULL);
insert into r5gridfield (GFD_FIELDID, GFD_GRIDID, GFD_BOTFUNCTION, GFD_BOTNUMBER, GFD_CONTROLTYPE, GFD_SCRIPTEVENT, GFD_TAGNAME, GFD_TAGPARAMS, GFD_AGGFUNC, GFD_FIELDTYPE, GFD_OCCURRENCE, GFD_DEPENDENT, GFD_SECENTITY)
values (v_field_id, v_grid_id, v_grid_name, 8, 'TEXT', NULL, 'entity', NULL, NULL, 'n', 1, null, NULL);
insert into r5queryfield (DQF_DDSPYID, DQF_FIELDID, DQF_COLUMNWIDTH, DQF_COLUMNORDER, DQF_UPDATECOUNT, DQF_VIEWTYPE)
values (v_dataspy_id, v_field_id, '180', 3, 0, 'LIST');


r5o7.o7maxseq(v_field_id, 'DDF', '1', sChk);
v_field_id_list := v_field_id_list || ',' || LTRIM(RTRIM(v_field_id));
v_grid_key_fields := LTRIM(RTRIM(v_field_id));
insert into r5ddfield (DDF_FIELDID, DDF_SOURCENAME, DDF_DATATYPE, DDF_DESC, DDF_VALUEMAPID, DDF_RENTITY, DDF_LVGRID)
values (v_field_id, 'a.aut_status', 'VARCHAR', NULL, null, NULL, NULL);
insert into r5gridfield (GFD_FIELDID, GFD_GRIDID, GFD_BOTFUNCTION, GFD_BOTNUMBER, GFD_CONTROLTYPE, GFD_SCRIPTEVENT, GFD_TAGNAME, GFD_TAGPARAMS, GFD_AGGFUNC, GFD_FIELDTYPE, GFD_OCCURRENCE, GFD_DEPENDENT, GFD_SECENTITY)
values (v_field_id, v_grid_id, v_grid_name, 9, 'TEXT', NULL, 'fromstatus', NULL, NULL, 'n', 1, null, NULL);
insert into r5queryfield (DQF_DDSPYID, DQF_FIELDID, DQF_COLUMNWIDTH, DQF_COLUMNORDER, DQF_UPDATECOUNT, DQF_VIEWTYPE)
values (v_dataspy_id, v_field_id, '180', 4, 0, 'LIST');


r5o7.o7maxseq(v_field_id, 'DDF', '1', sChk);
v_field_id_list := v_field_id_list || ',' || LTRIM(RTRIM(v_field_id));
insert into r5ddfield (DDF_FIELDID, DDF_SOURCENAME, DDF_DATATYPE, DDF_DESC, DDF_VALUEMAPID, DDF_RENTITY, DDF_LVGRID)
values (v_field_id, 'a.aut_statnew', 'VARCHAR', NULL, null, NULL, NULL);
insert into r5gridfield (GFD_FIELDID, GFD_GRIDID, GFD_BOTFUNCTION, GFD_BOTNUMBER, GFD_CONTROLTYPE, GFD_SCRIPTEVENT, GFD_TAGNAME, GFD_TAGPARAMS, GFD_AGGFUNC, GFD_FIELDTYPE, GFD_OCCURRENCE, GFD_DEPENDENT, GFD_SECENTITY)
values (v_field_id, v_grid_id, v_grid_name, 10, 'TEXT', NULL, 'tostatus', NULL, NULL, 'n', 1, null, NULL);
insert into r5queryfield (DQF_DDSPYID, DQF_FIELDID, DQF_COLUMNWIDTH, DQF_COLUMNORDER, DQF_UPDATECOUNT, DQF_VIEWTYPE)
values (v_dataspy_id, v_field_id, '180', 5, 0, 'LIST');


r5o7.o7maxseq(v_field_id, 'DDF', '1', sChk);
v_field_id_list := v_field_id_list || ',' || LTRIM(RTRIM(v_field_id));
insert into r5ddfield (DDF_FIELDID, DDF_SOURCENAME, DDF_DATATYPE, DDF_DESC, DDF_VALUEMAPID, DDF_RENTITY, DDF_LVGRID)
values (v_field_id, 'a.aut_type', 'VARCHAR', NULL, null, NULL, NULL);
insert into r5gridfield (GFD_FIELDID, GFD_GRIDID, GFD_BOTFUNCTION, GFD_BOTNUMBER, GFD_CONTROLTYPE, GFD_SCRIPTEVENT, GFD_TAGNAME, GFD_TAGPARAMS, GFD_AGGFUNC, GFD_FIELDTYPE, GFD_OCCURRENCE, GFD_DEPENDENT, GFD_SECENTITY)
values (v_field_id, v_grid_id, v_grid_name, 11, 'TEXT', NULL, 'userspecauth', NULL, NULL, 'n', 1, null, NULL);
insert into r5queryfield (DQF_DDSPYID, DQF_FIELDID, DQF_COLUMNWIDTH, DQF_COLUMNORDER, DQF_UPDATECOUNT, DQF_VIEWTYPE)
values (v_dataspy_id, v_field_id, '180', 6, 0, 'LIST');


r5o7.o7maxseq(v_field_id, 'DDF', '1', sChk);
v_field_id_list := v_field_id_list || ',' || LTRIM(RTRIM(v_field_id));
insert into r5ddfield (DDF_FIELDID, DDF_SOURCENAME, DDF_DATATYPE, DDF_DESC, DDF_VALUEMAPID, DDF_RENTITY, DDF_LVGRID)
values (v_field_id, 'ugr_desc', 'VARCHAR', NULL, null, NULL, NULL);
insert into r5gridfield (GFD_FIELDID, GFD_GRIDID, GFD_BOTFUNCTION, GFD_BOTNUMBER, GFD_CONTROLTYPE, GFD_SCRIPTEVENT, GFD_TAGNAME, GFD_TAGPARAMS, GFD_AGGFUNC, GFD_FIELDTYPE, GFD_OCCURRENCE, GFD_DEPENDENT, GFD_SECENTITY)
values (v_field_id, v_grid_id, v_grid_name, 12, 'TEXT', NULL, 'usergroupdesc', NULL, NULL, 'n', 1, null, NULL);
insert into r5queryfield (DQF_DDSPYID, DQF_FIELDID, DQF_COLUMNWIDTH, DQF_COLUMNORDER, DQF_UPDATECOUNT, DQF_VIEWTYPE)
values (v_dataspy_id, v_field_id, '180', 7, 0, 'LIST');

--fromstatusdesc
r5o7.o7maxseq(v_field_id, 'DDF', '1', sChk);
v_field_id_list := v_field_id_list || ',' || LTRIM(RTRIM(v_field_id));
insert into r5ddfield (DDF_FIELDID, DDF_SOURCENAME, DDF_DATATYPE, DDF_DESC, DDF_VALUEMAPID, DDF_RENTITY, DDF_LVGRID)
values (v_field_id, 'CASE a.aut_status WHEN ''-'' THEN NULL WHEN ''*'' THEN NULL ELSE R5O7.O7GET_DESC(:parameter.language,''UCOD'', a.aut_status, t.ent_statent, NULL) END', 'VARCHAR', NULL, null, NULL, NULL);
insert into r5gridfield (GFD_FIELDID, GFD_GRIDID, GFD_BOTFUNCTION, GFD_BOTNUMBER, GFD_CONTROLTYPE, GFD_SCRIPTEVENT, GFD_TAGNAME, GFD_TAGPARAMS, GFD_AGGFUNC, GFD_FIELDTYPE, GFD_OCCURRENCE, GFD_DEPENDENT, GFD_SECENTITY)
values (v_field_id, v_grid_id, v_grid_name, 13, 'TEXT', null, 'fromstatusdesc', null, null, 'n', 1, null, null);
insert into r5queryfield (DQF_DDSPYID, DQF_FIELDID, DQF_COLUMNWIDTH, DQF_COLUMNORDER, DQF_UPDATECOUNT, DQF_VIEWTYPE)
values (v_dataspy_id, v_field_id, '180', 8, 0, 'LIST');

--tostatusdesc
r5o7.o7maxseq(v_field_id, 'DDF', '1', sChk);
v_field_id_list := v_field_id_list || ',' || LTRIM(RTRIM(v_field_id));
insert into r5ddfield (DDF_FIELDID, DDF_SOURCENAME, DDF_DATATYPE, DDF_DESC, DDF_VALUEMAPID, DDF_RENTITY, DDF_LVGRID)
values (v_field_id, 'CASE a.aut_statnew WHEN ''-'' THEN NULL WHEN ''*'' THEN NULL ELSE R5O7.O7GET_DESC(:parameter.language,''UCOD'', a.aut_statnew, t.ent_statent, NULL) END', 'VARCHAR', NULL, null, NULL, NULL);
insert into r5gridfield (GFD_FIELDID, GFD_GRIDID, GFD_BOTFUNCTION, GFD_BOTNUMBER, GFD_CONTROLTYPE, GFD_SCRIPTEVENT, GFD_TAGNAME, GFD_TAGPARAMS, GFD_AGGFUNC, GFD_FIELDTYPE, GFD_OCCURRENCE, GFD_DEPENDENT, GFD_SECENTITY)
values (v_field_id, v_grid_id, v_grid_name, 14, 'TEXT', NULL, 'tostatusdesc', NULL, NULL, 'n', 1, null, NULL);
insert into r5queryfield (DQF_DDSPYID, DQF_FIELDID, DQF_COLUMNWIDTH, DQF_COLUMNORDER, DQF_UPDATECOUNT, DQF_VIEWTYPE)
values (v_dataspy_id, v_field_id, '180', 9, 0, 'LIST');


r5o7.o7maxseq(v_field_id, 'DDF', '1', sChk);
v_field_id_list := v_field_id_list || ',' || LTRIM(RTRIM(v_field_id));
insert into r5ddfield (DDF_FIELDID, DDF_SOURCENAME, DDF_DATATYPE, DDF_DESC, DDF_VALUEMAPID, DDF_RENTITY, DDF_LVGRID)
values (v_field_id, 'e.des_text', 'VARCHAR', NULL, null, NULL, NULL);
insert into r5gridfield (GFD_FIELDID, GFD_GRIDID, GFD_BOTFUNCTION, GFD_BOTNUMBER, GFD_CONTROLTYPE, GFD_SCRIPTEVENT, GFD_TAGNAME, GFD_TAGPARAMS, GFD_AGGFUNC, GFD_FIELDTYPE, GFD_OCCURRENCE, GFD_DEPENDENT, GFD_SECENTITY)
values (v_field_id, v_grid_id, v_grid_name, 15, 'TEXT', NULL, 'entitydesc', NULL, NULL, 'n', 1, null, NULL);
insert into r5queryfield (DQF_DDSPYID, DQF_FIELDID, DQF_COLUMNWIDTH, DQF_COLUMNORDER, DQF_UPDATECOUNT, DQF_VIEWTYPE)
values (v_dataspy_id, v_field_id, '180', 10, 0, 'LIST');


r5o7.o7maxseq(v_field_id, 'DDF', '1', sChk);
v_field_id_list := v_field_id_list || ',' || LTRIM(RTRIM(v_field_id));
insert into r5ddfield (DDF_FIELDID, DDF_SOURCENAME, DDF_DATATYPE, DDF_DESC, DDF_VALUEMAPID, DDF_RENTITY, DDF_LVGRID)
values (v_field_id, 't.ent_rentity', 'VARCHAR', NULL, null, NULL, NULL);
insert into r5gridfield (GFD_FIELDID, GFD_GRIDID, GFD_BOTFUNCTION, GFD_BOTNUMBER, GFD_CONTROLTYPE, GFD_SCRIPTEVENT, GFD_TAGNAME, GFD_TAGPARAMS, GFD_AGGFUNC, GFD_FIELDTYPE, GFD_OCCURRENCE, GFD_DEPENDENT, GFD_SECENTITY)
values (v_field_id, v_grid_id, v_grid_name, 16, 'TEXT', NULL, 'rentity', NULL, NULL, 'n', 1, null, NULL);
insert into r5queryfield (DQF_DDSPYID, DQF_FIELDID, DQF_COLUMNWIDTH, DQF_COLUMNORDER, DQF_UPDATECOUNT, DQF_VIEWTYPE)
values (v_dataspy_id, v_field_id, '180', 11, 0, 'LIST');


-------------------------------------------------------------------------------
-- Insert r5gridparams
-------------------------------------------------------------------------------

insert into r5gridparam
(
    gdp_gridid,
    gdp_param,
    gdp_tagname,
    gdp_datatype,
    gdp_updatecount
)
values
(
    v_grid_id,
    'parameter.language',
    null,
    null,
    0
);

--Update Grid
update r5grid set 
grd_keyfields = v_grid_key_fields, 
grd_filterablelist = v_field_id_list,
grd_sortablelist = v_field_id_list,
grd_displayablelist = v_field_id_list
where grd_gridid=v_grid_id;

commit;
end;

/
